<template>
	<view class="main-container">
		<view class="story-back" :style="{backgroundImage: 'url(' + backImgUrl + ')'}">
			<view class="story-back-text" :style="{backgroundImage: 'url(' + backImgTextUrl + ')'}"></view>
		</view>
		<view class="back-btn" @click="goBack"></view>
		<view class="light-btn" @click="goLight"></view>
		<view class="go-btn" @click="goResult"></view>
		<view class="save-story-btn" @click="goPoster(1)"></view>
		<view class="save-story-tips"></view>
		<view class="save-btm-btn" @click="goPoster(2)"></view>
		<painter class="painter" :dirty="true" v-if="palette != null" :palette="palette" @imgOK="onImgOK" @imgErr="onImgErr"></painter>
	</view>
</template>

<script>
	export default {
		onLoad(option) {
			this.genderType = option.gender;
			this.userName = option.name;
			this.userAvatarUrl = option.avatar;
		},
		mounted() {
			uni.showLoading({
				title: '加载中',
				mask: true
			});
			getApp().td_app_sdk.event({
				id: 'story-story',
				label: 'pv',
				params: {}
			});
			this.getRandomType();
			// this.backPosterImgUrl = getApp().globalData.storyBackImgUrl;
			// console.log('backPosterImgUrl === ', this.backPosterImgUrl);
			// this.userName = getApp().globalData.storyNickname;
			// this.userAvatarUrl = getApp().globalData.storyAvatar;
			this.backImgUrl = 'https://ikea-mrm.woaap.com/images/dreamstory/story-' + this.genderType + '-' + this.storyType + '.png';
			this.backImgTextUrl = 'https://ikea-mrm.woaap.com/images/dreamstory/story-1-' + this.storyType + '-text.png';
			console.log('story userName === ', this.userName);
			console.log('story userAvatarUrl === ', this.userAvatarUrl);
			console.log('story backImgUrl === ', this.backImgUrl);
			console.log('story backImgTextUrl === ', this.backImgTextUrl);
			this.$nextTick(() => {
				this.loadPainter();
			})
		},
		data() {
			return {
				genderType: 0, // 1 男 2 女
				storyType: 0,
				backImgUrl: '',
				backImgTextUrl: '',
				userName: '',
				userAvatarUrl: '',
				palette: {},
				// canvasScale: 3,
				canvasScale: 1,
				postUrl: '',
				isfadeout: false
			}
		},
		methods: {
			goLight() {
				getApp().td_app_sdk.event({
					id: 'story故事页面点亮勋章',
					label: 'click'
				});
				uni.navigateTo({
					url: '/pages/dreamstory/light'
				})
			},
			goResult() {
				getApp().td_app_sdk.event({
					id: 'story故事页面参与比赛',
					label: 'click'
				});
				uni.navigateTo({
					url: '/pages/dreamstory/result'
				})
			},
			goBack() {
				getApp().td_app_sdk.event({
					id: 'story故事页面返回',
					label: 'click'
				});
				uni.navigateBack();
			},
			getRandomType() {
				this.storyType = Math.floor(Math.random() * 100 % 6) + 1;
				console.log("lastestStoryIndex === ", getApp().globalData.lastestStoryIndex);
				console.log("storyType 1 === ", this.storyType);
				if (this.storyType === getApp().globalData.lastestStoryIndex) {
					if (this.storyType === 6) {
						this.storyType = 1;
					} else {
						this.storyType++;
					}
				}
				console.log("storyType 2 === ", this.storyType);
				getApp().globalData.lastestStoryIndex = this.storyType;
			},
			goPoster(type) {
				let trackId = ''
				if (type === 1) {
					trackId = 'story故事页面图片长按保存'
				} else if (type === 2) {
					trackId = 'story故事页面文字长按保存'
				}
				getApp().td_app_sdk.event({
					id: trackId,
					label: 'click'
				});
				this.handleSavePoster();
			},
			loadPainter() {
				// this.palette.width = `${750 * this.canvasScale}rpx`;
				// this.palette.height = `${1422 * this.canvasScale}rpx`;
				// this.palette.views = [];
				// this.palette.views.push(
				// 	{
				// 		// 头像
				// 		type: 'image',
				// 		url: this.userAvatarUrl,
				// 		css: {
				// 			top: `${143 * this.canvasScale}rpx`,
				// 			left: `${65 * this.canvasScale}rpx`,
				// 			width: `${108 * this.canvasScale}rpx`,
				// 			height: `${108 * this.canvasScale}rpx`
				// 		}
				// 	},
				// 	{
				// 		// 背景图
				// 		type: 'image',
				// 		url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back.png',
				// 		css: {
				// 			top: '0rpx',
				// 			left: '0rpx',
				// 			width: `${750 * this.canvasScale}rpx`,
				// 			height: `${1422 * this.canvasScale}rpx`
				// 		}
				// 	},
				// 	{
				// 		// 顶部标题
				// 		type: 'image',
				// 		url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back-titles.png',
				// 		css: {
				// 			top: '0rpx',
				// 			left: '0rpx',
				// 			width: `${750 * this.canvasScale}rpx`,
				// 			height: `${1422 * this.canvasScale}rpx`
				// 		}
				// 	},
				// 	{
				// 		// 故事图片
				// 		type: 'image',
				// 		url: this.backImgUrl,
				// 		css: {
				// 			top: `${365 * this.canvasScale}rpx`,
				// 			left: '0rpx',
				// 			width: `${750 * this.canvasScale}rpx`,
				// 			height: `${785 * this.canvasScale}rpx`
				// 		}
				// 	},
				// 	{
				// 		// 故事下方文字
				// 		type: 'image',
				// 		url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back-text.png',
				// 		css: {
				// 			top: `${1103 * this.canvasScale}rpx`,
				// 			left: '0rpx',
				// 			width: `${750 * this.canvasScale}rpx`,
				// 			height: `${33 * this.canvasScale}rpx`
				// 		}
				// 	},
				// 	{
				// 		// 用户名字
				// 		type: 'text',
				// 		text: `@${this.userName}`,
				// 		css: {
				// 			top: `${180 * this.canvasScale}rpx`,
				// 			left: `${194 * this.canvasScale}rpx`,
				// 			fontSize: `${28 * this.canvasScale}rpx`,
				// 			// fontWeight: '200',
				// 			color: '#333333',
				// 			height: `${30 * this.canvasScale}rpx`,
				// 			lineHeight: `${30 * this.canvasScale}rpx`,
				// 		}
				// 	}
				// )
				this.palette.width = `${750 * this.canvasScale}px`;
				this.palette.height = `${1422 * this.canvasScale}px`;
				this.palette.views = [];
				this.palette.views.push(
					{
						// 头像
						type: 'image',
						url: this.userAvatarUrl,
						css: {
							top: `${143 * this.canvasScale}px`,
							left: `${65 * this.canvasScale}px`,
							width: `${108 * this.canvasScale}px`,
							height: `${108 * this.canvasScale}px`
						}
					},
					{
						// 背景图
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back.png',
						css: {
							top: '0px',
							left: '0px',
							width: `${750 * this.canvasScale}px`,
							height: `${1422 * this.canvasScale}px`
						}
					},
					{
						// 顶部标题
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back-titles.png',
						css: {
							top: '0px',
							left: '0px',
							width: `${750 * this.canvasScale}px`,
							height: `${1422 * this.canvasScale}px`
						}
					},
					{
						// 故事图片
						type: 'image',
						url: this.backImgUrl,
						css: {
							top: `${365 * this.canvasScale}px`,
							left: '0px',
							width: `${750 * this.canvasScale}px`,
							height: `${785 * this.canvasScale}px`
						}
					},
					{
						// 故事下方文字
						type: 'image',
						url: 'https://ikea-mrm.woaap.com/images/dreamstory/poster-back-text.png',
						css: {
							top: `${1103 * this.canvasScale}px`,
							left: '0px',
							width: `${750 * this.canvasScale}px`,
							height: `${33 * this.canvasScale}px`
						}
					},
					{
						// 用户名字
						type: 'text',
						text: `@${this.userName}`,
						css: {
							top: `${180 * this.canvasScale}px`,
							left: `${194 * this.canvasScale}px`,
							fontSize: `${28 * this.canvasScale}px`,
							// fontWeight: '200',
							color: '#333333',
							height: `${30 * this.canvasScale}px`,
							lineHeight: `${30 * this.canvasScale}px`,
						}
					}
				)
				this.$forceUpdate();
			},
			onImgErr() {
				console.log("onImgErr");
				uni.showToast({
					icon: 'none',
					title: '海报生成失败'
				});
			},
			onImgOK(e) {
				console.log("onImgOK");
				console.log('postUrl === ', e.detail.path);
				this.$forceUpdate();
				this.postUrl = e.detail.path;
				uni.hideLoading();
				this.$nextTick(() => {
					this.isfadeout = true;
				})
			},
			handleSavePoster() {
				console.log("story handleSavePoster");
				uni.showLoading({
					title: '请稍后',
					mask: true
				});
				uni.getSetting({
					success: res => {
						console.log(res);
						if (!res.authSetting['scope.writePhotosAlbum']) {
							uni.authorize({
								scope: 'scope.writePhotosAlbum',
								success: () => {
									//1.1 允许授权
									this.saveImgToAlbum(this.postUrl);
								},
								fail() {
									//1.2 拒绝授权
									// 授权失败
									uni.showModal({
										title: '警告',
										content: '您点击了拒绝授权,将无法正常保存图片,点击确定重新获取授权。',
										success: function(res) {
											if (res.confirm) {
												uni.openSetting({
													success: res => {
														uni.showToast({
															icon: 'success',
															title: '授权成功',
															duration: 2000
														});
													}
												});
											}
										}
									});
								}
							});
						} else {
							this.saveImgToAlbum(this.postUrl);
						}
					}
				});
			},
			saveImgToAlbum(url) {
				console.log("saveImgToAlbum url === ", url);
				uni.showLoading({
					title: '图片保存中',
					mask: true
				});
				uni.saveImageToPhotosAlbum({
					filePath: url,
					success: (res) => {
						console.log("save image res === ", res);
						uni.hideLoading();
						uni.showToast({
							icon: 'success',
							title: '保存成功',
							duration: 2000
						});
					},
					fail(err) {
						console.log("save image err === ", err);
						uni.hideLoading();
						uni.showToast({
							icon: 'none',
							title: '保存失败',
							duration: 2000
						});
					}
				});
			}
		},
		// computed: {
		// 	backImgUrl() {
		// 		if (this.genderType === 0 || this.storyType === 0) {
		// 			return 'https://ikea-mrm.woaap.com/images/dreamstory/story-1-1.png';
		// 		}
		// 		return 'https://ikea-mrm.woaap.com/images/dreamstory/story-' + this.genderType + '-' + this.storyType + '.png'
		// 	},
		// 	backImgTextUrl() {
		// 		if (this.genderType === 0 || this.storyType === 0) {
		// 			return 'https://ikea-mrm.woaap.com/images/dreamstory/story-1-1-text.png';
		// 		}
		// 		return 'https://ikea-mrm.woaap.com/images/dreamstory/story-1-' + this.storyType + '-text.png'
		// 	}
		// },
		onShareAppMessage: function(res) {
			return {
				title: '穿越童梦奇缘 用童心制造快乐',
				path: 'pages/index/index',
				imageUrl: 'https://ikea-mrm.woaap.com/images/dreamstory/share.png'
			};
		},
	}
</script>

<style lang="scss" scoped>
.main-container {
	width: 100%;
	height: 100vh;
	background-image: url('https://ikea-mrm.woaap.com/images/dreamstory/story-back.png');
	background-size: cover;
	background-position: center;
	background-repeat: no-repeat;
	position: relative;
	overflow: hidden;
}
.story-back {
	position: absolute;
	z-index: 1;
	left: 0;
	top: calc(50vh - 405rpx);
	width: 750rpx;
	height: 785rpx;
	background-size: 100% 100%;
	background-position: center;
	background-repeat: no-repeat;
}
.story-back-text {
	position: absolute;
	z-index: 1;
	left: 0;
	bottom: 0;
	width: 750rpx;
	height: 50rpx;
	background-size: 100% 100%;
	background-position: center;
	background-repeat: no-repeat;
}
.back-btn {
	position: absolute;
	z-index: 1;
	left: 0;
	top: calc(50vh - 463rpx);
	width: 78rpx;
	height: 47rpx;
}
.light-btn {
	position: absolute;
	z-index: 1;
	top: calc(50vh + 450rpx);
	left: 32rpx;
	width: 331rpx;
	height: 100rpx;
	// background-color: rgba(0, 0, 0, .7);
}
.save-story-btn {
	position: absolute;
	z-index: 2;
	top: calc(50vh - 380rpx);
	left: calc((100vw - 670rpx) / 2);
	width: 670rpx;
	height: 690rpx;
}
.save-story-tips {
	position: absolute;
	z-index: 1;
	top: calc(50vh - 51rpx);
	left: calc((100vw - 278rpx) / 2);
	width: 278rpx;
	height: 60rpx;
	background-image: url('https://ikea-mrm.woaap.com/images/dreamstory/story-tips.png');
	background-size: 100% 100%;
	background-position: center;
	background-repeat: no-repeat;
	animation: tips 1s infinite;
}
.save-btm-btn {
	position: absolute;
	z-index: 1;
	width: 240rpx;
	height: 40rpx;
	top: calc(50vh + 568rpx);
	left: calc((100vw - 240rpx) / 2);
}
.go-btn {
	position: absolute;
	z-index: 1;
	top: calc(50vh + 450rpx);
	right: 36rpx;
	width: 331rpx;
	height: 100rpx;
	// background-color: rgba(0, 0, 0, .7);
}
.painter {
	position: absolute;
	left: 0;
	top: 200vh;
	// top: 0;
	// z-index: 10;
}
@keyframes tips {
	0% {
		opacity: 1;
	}
	50% {
		opacity: 0;
	}
	100% {
		opacity: 1;
	}
}
</style>